diff -ru hurd-0.0/ext2fs/ext2_fs.h hurd-0.1/ext2fs/ext2_fs.h
--- hurd-0.0/ext2fs/ext2_fs.h	Fri Aug  2 16:23:21 1996
+++ hurd-0.1/ext2fs/ext2_fs.h	Thu Aug 15 16:57:09 1996
@@ -16,13 +16,6 @@
 #ifndef _LINUX_EXT2_FS_H
 #define _LINUX_EXT2_FS_H
 
-typedef unsigned long u32;
-typedef long s32;
-typedef unsigned short u16;
-typedef short s16;
-typedef unsigned char u8;
-typedef signed char s8;
-
 /*
  * The second extended filesystem constants/structures
  */
@@ -33,21 +26,6 @@
 #undef EXT2FS_DEBUG
 
 /*
- * Define EXT2FS_DEBUG_CACHE to produce cache debug messages
- */
-#undef EXT2FS_DEBUG_CACHE
-
-/*
- * Define EXT2FS_CHECK_CACHE to add some checks to the name cache code
- */
-#undef EXT2FS_CHECK_CACHE
-
-/*
- * Define EXT2FS_PRE_02B_COMPAT to convert ext 2 fs prior to 0.2b
- */
-#undef EXT2FS_PRE_02B_COMPAT
-
-/*
  * Define EXT2_PREALLOCATE to preallocate data blocks for expanding files
  */
 #define EXT2_PREALLOCATE
@@ -55,18 +33,20 @@
 /*
  * The second extended file system version
  */
-#define EXT2FS_DATE		"95/03/19"
-#define EXT2FS_VERSION		"0.5a"
+#define EXT2FS_DATE		"95/08/09"
+#define EXT2FS_VERSION		"0.5b"
 
 /*
  * Debug code
  */
 #ifdef EXT2FS_DEBUG
-extern int ext2_debug_flag;
-#define ext2_debug(f, a...) \
- do { if (ext2_debug_flag) printf ("ext2fs: (debug) %s: " f "\n", __FUNCTION__ , ## a); } while (0)
+#	define ext2_debug(f, a...)	{ \
+					printk ("EXT2-fs DEBUG (%s, %d): %s:", \
+						__FILE__, __LINE__, __FUNCTION__); \
+				  	printk (f, ## a); \
+					}
 #else
-#define ext2_debug(f, a...)	(void)0
+#	define ext2_debug(f, a...)	/**/
 #endif
 
 /*
@@ -78,12 +58,13 @@
 #define EXT2_ACL_DATA_INO	 4	/* ACL inode */
 #define EXT2_BOOT_LOADER_INO	 5	/* Boot loader inode */
 #define EXT2_UNDEL_DIR_INO	 6	/* Undelete directory inode */
-#define EXT2_FIRST_INO		11	/* First non reserved inode */
+
+/* First non-reserved inode for old ext2 filesystems */
+#define EXT2_GOOD_OLD_FIRST_INO	11
 
 /*
  * The second extended file system magic number
  */
-#define EXT2_PRE_02B_MAGIC	0xEF51
 #define EXT2_SUPER_MAGIC	0xEF53
 
 /*
@@ -103,13 +84,24 @@
 # define EXT2_BLOCK_SIZE(s)		(EXT2_MIN_BLOCK_SIZE << (s)->s_log_block_size)
 #endif
 #define EXT2_ACLE_PER_BLOCK(s)		(EXT2_BLOCK_SIZE(s) / sizeof (struct ext2_acl_entry))
-#define	EXT2_ADDR_PER_BLOCK(s)		(EXT2_BLOCK_SIZE(s) / sizeof (u32))
+#define	EXT2_ADDR_PER_BLOCK(s)		(EXT2_BLOCK_SIZE(s) / sizeof (__u32))
 #ifdef __KERNEL__
-# define EXT2_BLOCK_SIZE_BITS(s)	((s)->u.ext2_sb.s_es->s_log_block_size + 10)
+# define EXT2_BLOCK_SIZE_BITS(s)	((s)->s_blocksize_bits)
 #else
 # define EXT2_BLOCK_SIZE_BITS(s)	((s)->s_log_block_size + 10)
 #endif
-#define	EXT2_INODES_PER_BLOCK(s)	(EXT2_BLOCK_SIZE(s) / sizeof (struct ext2_inode))
+#ifdef __KERNEL__
+#define	EXT2_ADDR_PER_BLOCK_BITS(s)	((s)->u.ext2_sb.s_addr_per_block_bits)
+#define EXT2_INODE_SIZE(s)		((s)->u.ext2_sb.s_inode_size)
+#define EXT2_FIRST_INO(s)		((s)->u.ext2_sb.s_first_ino)
+#else
+#define EXT2_INODE_SIZE(s)	(((s)->s_rev_level == EXT2_GOOD_OLD_REV) ? \
+				 EXT2_GOOD_OLD_INODE_SIZE : \
+				 (s)->s_inode_size)
+#define EXT2_FIRST_INO(s)	(((s)->s_rev_level == EXT2_GOOD_OLD_REV) ? \
+				 EXT2_GOOD_OLD_FIRST_INO : \
+				 (s)->s_first_ino)
+#endif
 
 /*
  * Macro-instructions used to manage fragments
@@ -130,45 +122,36 @@
  */
 struct ext2_acl_header	/* Header of Access Control Lists */
 {
-	u32	aclh_size;
-	u32	aclh_file_count;
-	u32	aclh_acle_count;
-	u32	aclh_first_acle;
+	__u32	aclh_size;
+	__u32	aclh_file_count;
+	__u32	aclh_acle_count;
+	__u32	aclh_first_acle;
 };
 
 struct ext2_acl_entry	/* Access Control List Entry */
 {
-	u32	acle_size;
-	u16	acle_perms;	/* Access permissions */
-	u16	acle_type;	/* Type of entry */
-	u16	acle_tag;	/* User or group identity */
-	u16	acle_pad1;
-	u32	acle_next;	/* Pointer on next entry for the */
+	__u32	acle_size;
+	__u16	acle_perms;	/* Access permissions */
+	__u16	acle_type;	/* Type of entry */
+	__u16	acle_tag;	/* User or group identity */
+	__u16	acle_pad1;
+	__u32	acle_next;	/* Pointer on next entry for the */
 					/* same inode or on next free entry */
 };
 
 /*
  * Structure of a blocks group descriptor
  */
-struct ext2_old_group_desc
-{
-	u32	bg_block_bitmap;		/* Blocks bitmap block */
-	u32	bg_inode_bitmap;		/* Inodes bitmap block */
-	u32	bg_inode_table;		/* Inodes table block */
-	u16	bg_free_blocks_count;	/* Free blocks count */
-	u16	bg_free_inodes_count;	/* Free inodes count */
-};
-
 struct ext2_group_desc
 {
-	u32	bg_block_bitmap;		/* Blocks bitmap block */
-	u32	bg_inode_bitmap;		/* Inodes bitmap block */
-	u32	bg_inode_table;		/* Inodes table block */
-	u16	bg_free_blocks_count;	/* Free blocks count */
-	u16	bg_free_inodes_count;	/* Free inodes count */
-	u16	bg_used_dirs_count;	/* Directories count */
-	u16	bg_pad;
-	u32	bg_reserved[3];
+	__u32	bg_block_bitmap;		/* Blocks bitmap block */
+	__u32	bg_inode_bitmap;		/* Inodes bitmap block */
+	__u32	bg_inode_table;		/* Inodes table block */
+	__u16	bg_free_blocks_count;	/* Free blocks count */
+	__u16	bg_free_inodes_count;	/* Free inodes count */
+	__u16	bg_used_dirs_count;	/* Directories count */
+	__u16	bg_pad;
+	__u32	bg_reserved[3];
 };
 
 /*
@@ -178,6 +161,7 @@
 # define EXT2_BLOCKS_PER_GROUP(s)	((s)->u.ext2_sb.s_blocks_per_group)
 # define EXT2_DESC_PER_BLOCK(s)		((s)->u.ext2_sb.s_desc_per_block)
 # define EXT2_INODES_PER_GROUP(s)	((s)->u.ext2_sb.s_inodes_per_group)
+# define EXT2_DESC_PER_BLOCK_BITS(s)	((s)->u.ext2_sb.s_desc_per_block_bits)
 #else
 # define EXT2_BLOCKS_PER_GROUP(s)	((s)->s_blocks_per_group)
 # define EXT2_DESC_PER_BLOCK(s)		(EXT2_BLOCK_SIZE(s) / sizeof (struct ext2_group_desc))
@@ -203,7 +187,8 @@
 #define EXT2_IMMUTABLE_FL		0x00000010 /* Immutable file */
 #define EXT2_APPEND_FL			0x00000020 /* writes to file may only append */
 #define EXT2_NODUMP_FL			0x00000040 /* do not dump file */
-
+#define EXT2_RESERVED_FL		0x80000000 /* reserved for ext2 lib */
+	
 /*
  * ioctl commands
  */
@@ -216,53 +201,53 @@
  * Structure of an inode on the disk
  */
 struct ext2_inode {
-	u16 i_mode;		/* File mode */
-	u16 i_uid;		/* Owner Uid */
-	u32  i_size;		/* Size in bytes */
-	u32  i_atime;		/* Access time */
-	u32  i_ctime;		/* Creation time */
-	u32  i_mtime;		/* Modification time */
-	u32  i_dtime;		/* Deletion Time */
-	u16 i_gid;		/* Group Id */
-	u16 i_links_count;	/* Links count */
-	u32  i_blocks;	/* Blocks count */
-	u32  i_flags;		/* File flags */
+	__u16	i_mode;		/* File mode */
+	__u16	i_uid;		/* Owner Uid */
+	__u32	i_size;		/* Size in bytes */
+	__u32	i_atime;	/* Access time */
+	__u32	i_ctime;	/* Creation time */
+	__u32	i_mtime;	/* Modification time */
+	__u32	i_dtime;	/* Deletion Time */
+	__u16	i_gid;		/* Group Id */
+	__u16	i_links_count;	/* Links count */
+	__u32	i_blocks;	/* Blocks count */
+	__u32	i_flags;	/* File flags */
 	union {
 		struct {
-			u32  l_i_reserved1;
+			__u32  l_i_reserved1;
 		} linux1;
 		struct {
-			u32  h_i_translator;
+			__u32  h_i_translator;
 		} hurd1;
 		struct {
-			u32  m_i_reserved1;
+			__u32  m_i_reserved1;
 		} masix1;
 	} osd1;				/* OS dependent 1 */
-	u32	i_block[EXT2_N_BLOCKS];/* Pointers to blocks */
-	u32	i_version;	/* File version (for NFS) */
-	u32	i_file_acl;	/* File ACL */
-	u32	i_dir_acl;	/* Directory ACL */
-	u32	i_faddr;		/* Fragment address */
+	__u32	i_block[EXT2_N_BLOCKS];/* Pointers to blocks */
+	__u32	i_version;	/* File version (for NFS) */
+	__u32	i_file_acl;	/* File ACL */
+	__u32	i_dir_acl;	/* Directory ACL */
+	__u32	i_faddr;	/* Fragment address */
 	union {
 		struct {
-			u8	l_i_frag;	/* Fragment number */
-			u8	l_i_fsize;	/* Fragment size */
-			u16	i_pad1;
-			u32	l_i_reserved2[2];
+			__u8	l_i_frag;	/* Fragment number */
+			__u8	l_i_fsize;	/* Fragment size */
+			__u16	i_pad1;
+			__u32	l_i_reserved2[2];
 		} linux2;
 		struct {
-			u8	h_i_frag;	/* Fragment number */
-			u8	h_i_fsize;	/* Fragment size */
-			u16	h_i_mode_high;
-			u16	h_i_uid_high;
-			u16	h_i_gid_high;
-			u32	h_i_author;
+			__u8	h_i_frag;	/* Fragment number */
+			__u8	h_i_fsize;	/* Fragment size */
+			__u16	h_i_mode_high;
+			__u16	h_i_uid_high;
+			__u16	h_i_gid_high;
+			__u32	h_i_author;
 		} hurd2;
 		struct {
-			u8	m_i_frag;	/* Fragment number */
-			u8	m_i_fsize;	/* Fragment size */
-			u16	m_pad1;
-			u32	m_i_reserved2[2];
+			__u8	m_i_frag;	/* Fragment number */
+			__u8	m_i_fsize;	/* Fragment size */
+			__u16	m_pad1;
+			__u32	m_i_reserved2[2];
 		} masix2;
 	} osd2;				/* OS dependent 2 */
 };
@@ -333,40 +318,76 @@
  * Structure of the super block
  */
 struct ext2_super_block {
-	u32	s_inodes_count;		/* Inodes count */
-	u32	s_blocks_count;		/* Blocks count */
-	u32	s_r_blocks_count;	/* Reserved blocks count */
-	u32	s_free_blocks_count;	/* Free blocks count */
-	u32	s_free_inodes_count;	/* Free inodes count */
-	u32	s_first_data_block;	/* First Data Block */
-	u32	s_log_block_size;	/* Block size */
-	s32	s_log_frag_size;	/* Fragment size */
-	u32	s_blocks_per_group;	/* # Blocks per group */
-	u32	s_frags_per_group;	/* # Fragments per group */
-	u32	s_inodes_per_group;	/* # Inodes per group */
-	u32	s_mtime;		/* Mount time */
-	u32	s_wtime;		/* Write time */
-	u16	s_mnt_count;		/* Mount count */
-	s16	s_max_mnt_count;	/* Maximal mount count */
-	u16	s_magic;		/* Magic signature */
-	u16	s_state;		/* File system state */
-	u16	s_errors;		/* Behaviour when detecting errors */
-	u16	s_pad;
-	u32	s_lastcheck;		/* time of last check */
-	u32	s_checkinterval;	/* max. time between checks */
-	u32	s_creator_os;		/* OS */
-	u32	s_rev_level;		/* Revision level */
-	u16	s_def_resuid;		/* Default uid for reserved blocks */
-	u16	s_def_resgid;		/* Default gid for reserved blocks */
-	u32	s_reserved[235];	/* Padding to the end of the block */
+	__u32	s_inodes_count;		/* Inodes count */
+	__u32	s_blocks_count;		/* Blocks count */
+	__u32	s_r_blocks_count;	/* Reserved blocks count */
+	__u32	s_free_blocks_count;	/* Free blocks count */
+	__u32	s_free_inodes_count;	/* Free inodes count */
+	__u32	s_first_data_block;	/* First Data Block */
+	__u32	s_log_block_size;	/* Block size */
+	__s32	s_log_frag_size;	/* Fragment size */
+	__u32	s_blocks_per_group;	/* # Blocks per group */
+	__u32	s_frags_per_group;	/* # Fragments per group */
+	__u32	s_inodes_per_group;	/* # Inodes per group */
+	__u32	s_mtime;		/* Mount time */
+	__u32	s_wtime;		/* Write time */
+	__u16	s_mnt_count;		/* Mount count */
+	__s16	s_max_mnt_count;	/* Maximal mount count */
+	__u16	s_magic;		/* Magic signature */
+	__u16	s_state;		/* File system state */
+	__u16	s_errors;		/* Behaviour when detecting errors */
+	__u16	s_minor_rev_level; 	/* minor revision level */
+	__u32	s_lastcheck;		/* time of last check */
+	__u32	s_checkinterval;	/* max. time between checks */
+	__u32	s_creator_os;		/* OS */
+	__u32	s_rev_level;		/* Revision level */
+	__u16	s_def_resuid;		/* Default uid for reserved blocks */
+	__u16	s_def_resgid;		/* Default gid for reserved blocks */
+	/*
+	 * These fields are for EXT2_DYNAMIC_REV superblocks only.
+	 *
+	 * Note: the difference between the compatible feature set and
+	 * the incompatible feature set is that if there is a bit set
+	 * in the incompatible feature set that the kernel doesn't
+	 * know about, it should refuse to mount the filesystem.
+	 * 
+	 * e2fsck's requirements are more strict; if it doesn't know
+	 * about a feature in either the compatible or incompatible
+	 * feature set, it must abort and not try to meddle with
+	 * things it doesn't understand...
+	 */
+	__u32	s_first_ino; 		/* First non-reserved inode */
+	__u16   s_inode_size; 		/* size of inode structure */
+	__u16	s_block_group_nr; 	/* block group # of this superblock */
+	__u32	s_feature_compat; 	/* compatible feature set */
+	__u32	s_feature_incompat; 	/* incompatible feature set */
+	__u32	s_feature_ro_compat; 	/* readonly-compatible feature set */
+	__u32	s_reserved[230];	/* Padding to the end of the block */
 };
 
+/*
+ * Codes for operating systems
+ */
 #define EXT2_OS_LINUX		0
 #define EXT2_OS_HURD		1
 #define EXT2_OS_MASIX		2
+#define EXT2_OS_FREEBSD		3
+#define EXT2_OS_LITES		4
 
-#define EXT2_CURRENT_REV	0
+/*
+ * Revision levels
+ */
+#define EXT2_GOOD_OLD_REV	0	/* The good old (original) format */
+#define EXT2_DYNAMIC_REV	1 	/* V2 format w/ dynamic inode sizes */
+
+#define EXT2_CURRENT_REV	EXT2_GOOD_OLD_REV
+#define EXT2_MAX_SUPP_REV	EXT2_DYNAMIC_REV
 
+#define EXT2_GOOD_OLD_INODE_SIZE 128
+
+/*
+ * Default values for user and/or group using reserved blocks
+ */
 #define	EXT2_DEF_RESUID		0
 #define	EXT2_DEF_RESGID		0
 
@@ -376,9 +397,9 @@
 #define EXT2_NAME_LEN 255
 
 struct ext2_dir_entry {
-	u32	inode;			/* Inode number */
-	u16	rec_len;		/* Directory entry length */
-	u16	name_len;		/* Name length */
+	__u32	inode;			/* Inode number */
+	__u16	rec_len;		/* Directory entry length */
+	__u16	name_len;		/* Name length */
 	char	name[EXT2_NAME_LEN];	/* File name */
 };
 
@@ -391,5 +412,121 @@
 #define EXT2_DIR_ROUND 			(EXT2_DIR_PAD - 1)
 #define EXT2_DIR_REC_LEN(name_len)	(((name_len) + 8 + EXT2_DIR_ROUND) & \
 					 ~EXT2_DIR_ROUND)
+
+/*
+ * Feature set definitions --- none are defined as of now
+ */
+#define EXT2_FEATURE_COMPAT_SUPP	0
+#define EXT2_FEATURE_INCOMPAT_SUPP	0
+#define EXT2_FEATURE_RO_COMPAT_SUPP	0
+
+#ifdef __KERNEL__
+/*
+ * Function prototypes
+ */
+
+/*
+ * Ok, these declarations are also in <linux/kernel.h> but none of the
+ * ext2 source programs needs to include it so they are duplicated here.
+ */
+# define NORET_TYPE    /**/
+# define ATTRIB_NORET  __attribute__((noreturn))
+# define NORET_AND     noreturn,
+
+/* acl.c */
+extern int ext2_permission (struct inode *, int);
+
+/* balloc.c */
+extern int ext2_new_block (const struct inode *, unsigned long,
+			   __u32 *, __u32 *, int *);
+extern void ext2_free_blocks (const struct inode *, unsigned long,
+			      unsigned long);
+extern unsigned long ext2_count_free_blocks (struct super_block *);
+extern void ext2_check_blocks_bitmap (struct super_block *);
+
+/* bitmap.c */
+extern unsigned long ext2_count_free (struct buffer_head *, unsigned);
+
+/* dir.c */
+extern int ext2_check_dir_entry (const char *, struct inode *,
+				 struct ext2_dir_entry *, struct buffer_head *,
+				 unsigned long);
+
+/* file.c */
+extern int ext2_read (struct inode *, struct file *, char *, int);
+extern int ext2_write (struct inode *, struct file *, char *, int);
+
+/* fsync.c */
+extern int ext2_sync_file (struct inode *, struct file *);
+
+/* ialloc.c */
+extern struct inode * ext2_new_inode (const struct inode *, int, int *);
+extern void ext2_free_inode (struct inode *);
+extern unsigned long ext2_count_free_inodes (struct super_block *);
+extern void ext2_check_inodes_bitmap (struct super_block *);
+
+/* inode.c */
+extern int ext2_bmap (struct inode *, int);
+
+extern struct buffer_head * ext2_getblk (struct inode *, long, int, int *);
+extern struct buffer_head * ext2_bread (struct inode *, int, int, int *);
+
+extern int ext2_getcluster (struct inode * inode, long block);
+extern void ext2_read_inode (struct inode *);
+extern void ext2_write_inode (struct inode *);
+extern void ext2_put_inode (struct inode *);
+extern int ext2_sync_inode (struct inode *);
+extern void ext2_discard_prealloc (struct inode *);
+
+/* ioctl.c */
+extern int ext2_ioctl (struct inode *, struct file *, unsigned int,
+		       unsigned long);
+
+/* namei.c */
+extern void ext2_release (struct inode *, struct file *);
+extern int ext2_lookup (struct inode *,const char *, int, struct inode **);
+extern int ext2_create (struct inode *,const char *, int, int,
+			struct inode **);
+extern int ext2_mkdir (struct inode *, const char *, int, int);
+extern int ext2_rmdir (struct inode *, const char *, int);
+extern int ext2_unlink (struct inode *, const char *, int);
+extern int ext2_symlink (struct inode *, const char *, int, const char *);
+extern int ext2_link (struct inode *, struct inode *, const char *, int);
+extern int ext2_mknod (struct inode *, const char *, int, int, int);
+extern int ext2_rename (struct inode *, const char *, int,
+			struct inode *, const char *, int, int);
+
+/* super.c */
+extern void ext2_error (struct super_block *, const char *, const char *, ...)
+	__attribute__ ((format (printf, 3, 4)));
+extern NORET_TYPE void ext2_panic (struct super_block *, const char *,
+				   const char *, ...)
+	__attribute__ ((NORET_AND format (printf, 3, 4)));
+extern void ext2_warning (struct super_block *, const char *, const char *, ...)
+	__attribute__ ((format (printf, 3, 4)));
+extern void ext2_put_super (struct super_block *);
+extern void ext2_write_super (struct super_block *);
+extern int ext2_remount (struct super_block *, int *, char *);
+extern struct super_block * ext2_read_super (struct super_block *,void *,int);
+extern int init_ext2_fs(void);
+extern void ext2_statfs (struct super_block *, struct statfs *, int);
+
+/* truncate.c */
+extern void ext2_truncate (struct inode *);
+
+/*
+ * Inodes and files operations
+ */
+
+/* dir.c */
+extern struct inode_operations ext2_dir_inode_operations;
+
+/* file.c */
+extern struct inode_operations ext2_file_inode_operations;
+
+/* symlink.c */
+extern struct inode_operations ext2_symlink_inode_operations;
+
+#endif	/* __KERNEL__ */
 
 #endif	/* _LINUX_EXT2_FS_H */
diff -ru hurd-0.0/ext2fs/ext2_fs_i.h hurd-0.1/ext2fs/ext2_fs_i.h
--- hurd-0.0/ext2fs/ext2_fs_i.h	Fri Apr 14 18:56:16 1995
+++ hurd-0.1/ext2fs/ext2_fs_i.h	Tue Aug 13 11:53:17 1996
@@ -20,21 +20,21 @@
  * second extended file system inode data in memory
  */
 struct ext2_inode_info {
-	u32	i_data[15];
-	u32	i_flags;
-	u32	i_faddr;
-	u8	i_frag_no;
-	u8	i_frag_size;
-	u16	i_osync;
-	u32	i_file_acl;
-	u32	i_dir_acl;
-	u32	i_dtime;
-	u32	i_version;
-	u32	i_block_group;
-	u32	i_next_alloc_block;
-	u32	i_next_alloc_goal;
-	u32	i_prealloc_block;
-	u32	i_prealloc_count;
+	__u32	i_data[15];
+	__u32	i_flags;
+	__u32	i_faddr;
+	__u8	i_frag_no;
+	__u8	i_frag_size;
+	__u16	i_osync;
+	__u32	i_file_acl;
+	__u32	i_dir_acl;
+	__u32	i_dtime;
+	__u32	i_version;
+	__u32	i_block_group;
+	__u32	i_next_alloc_block;
+	__u32	i_next_alloc_goal;
+	__u32	i_prealloc_block;
+	__u32	i_prealloc_count;
 };
 
 #endif	/* _LINUX_EXT2_FS_I */
diff -ru hurd-0.0/ext2fs/ext2fs.c hurd-0.1/ext2fs/ext2fs.c
--- hurd-0.0/ext2fs/ext2fs.c	Fri Aug  2 16:23:21 1996
+++ hurd-0.1/ext2fs/ext2fs.c	Fri Sep  6 16:05:22 1996
@@ -27,6 +27,7 @@
 #include <string.h>
 #include <error.h>
 #include <argz.h>
+#include <version.h>
 #include "ext2fs.h"
 
 /* ---------------------------------------------------------------- */
@@ -40,9 +41,8 @@
 int diskfs_shortcut_ifsock = 1;
 
 char *diskfs_server_name = "ext2fs";
-int diskfs_major_version = 0;
-int diskfs_minor_version = 0;
-int diskfs_edit_version = 0;
+char *diskfs_server_version = HURD_VERSION;
+char *diskfs_extra_version = "ext2 " EXT2FS_VERSION;
 
 int diskfs_synchronous = 0;
 int diskfs_readonly = 0;
@@ -214,8 +214,11 @@
   buf = free_page_bufs;
   if (buf == 0)
     {
+      error_t err;
       spin_unlock (&free_page_bufs_lock);
-      vm_allocate (mach_task_self (), &buf, vm_page_size, 1);
+      err = vm_allocate (mach_task_self (), &buf, vm_page_size, 1);
+      if (err)
+	buf = 0;
     }
   else
     {
diff -ru hurd-0.0/ext2fs/ext2fs.h hurd-0.1/ext2fs/ext2fs.h
--- hurd-0.0/ext2fs/ext2fs.h	Sat Jul 20 11:04:34 1996
+++ hurd-0.1/ext2fs/ext2fs.h	Tue Sep  3 10:20:42 1996
@@ -29,8 +29,29 @@
 #include <rwlock.h>
 
 #define __hurd__		/* Enable some hurd-specific fields.  */
+
+/* Types used by the ext2 header files.  */
+typedef u_int32_t __u32;
+typedef int32_t   __s32;
+typedef u_int16_t __u16;
+typedef int16_t   __s16;
+typedef u_int8_t  __u8;
+typedef int8_t    __s8;
+
 #include "ext2_fs.h"
 #include "ext2_fs_i.h"
+
+/* If ext2_fs.h defined a debug routine, undef it and use our own.  */
+#undef ext2_debug
+
+#ifdef EXT2FS_DEBUG
+extern int ext2_debug_flag;
+#define ext2_debug(f, a...) \
+ do { if (ext2_debug_flag) printf ("ext2fs: (debug) %s: " f "\n", __FUNCTION__ , ## a); } while (0)
+#else
+#define ext2_debug(f, a...)	(void)0
+#endif
+
 #undef __hurd__
 
 /* Define this if memory objects should not be cached by the kernel.
@@ -42,7 +63,7 @@
 int printf (const char *fmt, ...);
 
 /* A block number.  */
-typedef u32 block_t;
+typedef __u32 block_t;
 
 /* ---------------------------------------------------------------- */
 
@@ -163,6 +184,9 @@
   /* True if the last page of the file has been made writable, but is only
      partially allocated.  */
   int last_page_partially_writable;
+
+  /* Index to start a directory lookup at.  */
+  int dir_idx;
 };
 
 struct user_pager_info
@@ -299,7 +323,6 @@
   unsigned long bg_num = (inum - 1) / inodes_per_group;
   unsigned long group_inum = (inum - 1) % inodes_per_group;
   struct ext2_group_desc *bg = group_desc(bg_num);
-  unsigned long inodes_per_block = EXT2_INODES_PER_BLOCK(sblock);
   block_t block = bg->bg_inode_table + (group_inum / inodes_per_block);
   return ((struct ext2_inode *)bptr(block)) + group_inum % inodes_per_block;
 }
diff -ru hurd-0.0/ext2fs/hyper.c hurd-0.1/ext2fs/hyper.c
--- hurd-0.0/ext2fs/hyper.c	Tue Jun 25 17:29:07 1996
+++ hurd-0.1/ext2fs/hyper.c	Thu Aug 15 16:57:10 1996
@@ -107,7 +107,7 @@
 		sblock->s_blocks_count << log2_dev_blocks_per_fs_block);
 
   /* Set these handy variables.  */
-  inodes_per_block = block_size / sizeof (struct ext2_inode);
+  inodes_per_block = block_size / EXT2_INODE_SIZE (sblock);
 
   frag_size = EXT2_MIN_FRAG_SIZE << sblock->s_log_frag_size;
   if (frag_size)
@@ -115,6 +115,23 @@
   else
     ext2_panic ("frag size is zero!");
 
+  if (sblock->s_rev_level > EXT2_GOOD_OLD_REV)
+    {
+      if (sblock->s_feature_incompat & ~EXT2_FEATURE_INCOMPAT_SUPP)
+	ext2_panic ("could not mount because of unsupported optional features"
+		    " (0x%x)",
+		    sblock->s_feature_incompat & ~EXT2_FEATURE_INCOMPAT_SUPP);
+      if (sblock->s_feature_ro_compat & ~EXT2_FEATURE_RO_COMPAT_SUPP)
+	{
+	  ext2_warning ("mounted readonly because of"
+			" unsupported optional features (0x%x)",
+			sblock->s_feature_ro_compat & ~EXT2_FEATURE_RO_COMPAT_SUPP);
+	  diskfs_readonly = 1;
+	}
+      if (sblock->s_inode_size != EXT2_GOOD_OLD_INODE_SIZE)
+	ext2_panic ("inode size %d isn't supported", sblock->s_inode_size);
+    }
+
   groups_count =
     ((sblock->s_blocks_count - sblock->s_first_data_block +
       sblock->s_blocks_per_group - 1)
@@ -144,7 +161,7 @@
   vm_allocate (mach_task_self (), &zeroblock, block_size, 1);
 }
 
-void
+error_t
 diskfs_set_hypermetadata (int wait, int clean)
 {
   if (clean && ext2fs_clean && !(sblock->s_state & EXT2_VALID_FS))
@@ -168,6 +185,9 @@
    }
 
   sync_global (wait);
+
+  /* Should check writability here and return EROFS if necessary. XXX */
+  return 0;
 }
 
 void
diff -ru hurd-0.0/ext2fs/ialloc.c hurd-0.1/ext2fs/ialloc.c
--- hurd-0.0/ext2fs/ialloc.c	Thu Apr 11 13:31:02 1996
+++ hurd-0.1/ext2fs/ialloc.c	Thu Aug 15 16:57:11 1996
@@ -63,7 +63,7 @@
 
   spin_lock (&global_lock);
 
-  if (inum < EXT2_FIRST_INO || inum > sblock->s_inodes_count)
+  if (inum < EXT2_FIRST_INO (sblock) || inum > sblock->s_inodes_count)
     {
       ext2_error ("reserved inode or nonexistent inode: %u", inum);
       spin_unlock (&global_lock);
@@ -236,7 +236,7 @@
     }
 
   inum += i * sblock->s_inodes_per_group + 1;
-  if (inum < EXT2_FIRST_INO || inum > sblock->s_inodes_count)
+  if (inum < EXT2_FIRST_INO (sblock) || inum > sblock->s_inodes_count)
     {
       ext2_error ("reserved inode or inode > inodes count - "
 		  "block_group = %d,inode=%d", i, inum);
diff -ru hurd-0.0/ext2fs/inode.c hurd-0.1/ext2fs/inode.c
--- hurd-0.0/ext2fs/inode.c	Fri Aug  2 16:23:21 1996
+++ hurd-0.1/ext2fs/inode.c	Tue Sep  3 10:20:43 1996
@@ -73,6 +73,7 @@
       return ENOMEM;
     }
   dn->dirents = 0;
+  dn->dir_idx = 0;
   dn->pager = 0;
   rwlock_init (&dn->alloc_lock);
   pokel_init (&dn->indir_pokel, disk_pager, disk_image);
@@ -182,7 +183,6 @@
 read_disknode (struct node *np)
 {
   error_t err;
-  unsigned offset;
   static int fsid, fsidset;
   struct stat *st = &np->dn_stat;
   struct disknode *dn = np->dn;
@@ -255,6 +255,9 @@
   info->i_next_alloc_goal = 0;
   info->i_prealloc_count = 0;
 
+  /* Set to a conservative value.  */
+  dn->last_page_partially_writable = 0;
+
   if (S_ISCHR(st->st_mode) || S_ISBLK(st->st_mode))
     st->st_rdev = di->i_block[0];
   else
@@ -266,14 +269,29 @@
     }
 
   diskfs_end_catch_exception ();
-
-  /* Set these to conservative values.  */
-  dn->last_page_partially_writable = 0;
   
-  np->allocsize = np->dn_stat.st_size;
-  offset = np->allocsize & ((1 << log2_block_size) - 1);
-  if (offset > 0)
-    np->allocsize += block_size - offset;
+  if (S_ISREG (st->st_mode) || S_ISDIR (st->st_mode)
+      || (S_ISLNK (st->st_mode) && st->st_blocks))
+    {
+      unsigned offset;
+
+      np->allocsize = np->dn_stat.st_size;
+
+      /* Round up to a block multiple.  */
+      offset = np->allocsize & ((1 << log2_block_size) - 1);
+      if (offset > 0)
+	np->allocsize += block_size - offset;
+    }
+  else
+    /* Allocsize should be zero for anything except directories, files, and
+       long symlinks.  These are the only things allowed to have any blocks
+       allocated as well, although st_size may be zero for any type (cases
+       where st_blocks=0 and st_size>0 include fast symlinks, and, under
+       linux, some devices).  */
+    {
+      np->allocsize = 0;
+      assert (st->st_blocks == 0);
+    }
 
   return 0;
 }
@@ -540,7 +558,7 @@
   st->f_namelen = 0;
   return 0;
 }
-
+
 /* Implement the diskfs_set_translator callback from the diskfs
    library; see <hurd/diskfs.h> for the interface description. */
 error_t
@@ -646,7 +664,57 @@
   *namelen = datalen;
   return 0;
 }
+
+/* The maximum size of a symlink store in the inode (including '\0').  */
+#define MAX_INODE_SYMLINK \
+  (EXT2_N_BLOCKS * sizeof (((struct ext2_inode *)0)->i_block[0]))
 
+/* Write an in-inode symlink, or return EINVAL if we can't.  */
+static error_t
+write_symlink (struct node *node, char *target)
+{
+  size_t len = strlen (target) + 1;
+
+  if (len > MAX_INODE_SYMLINK)
+    return EINVAL;
+
+  assert (node->dn_stat.st_blocks == 0);
+
+  bcopy (target, node->dn->info.i_data, len);
+  node->dn_stat.st_size = len - 1;
+  node->dn_set_ctime = 1;
+  node->dn_set_mtime = 1;
+
+  return 0;
+}
+
+/* Read an in-inode symlink, or return EINVAL if we can't.  */
+static error_t
+read_symlink (struct node *node, char *target)
+{
+  if (node->dn_stat.st_blocks)
+    return EINVAL;
+
+  assert (node->dn_stat.st_size < MAX_INODE_SYMLINK);
+
+  bcopy (node->dn->info.i_data, target, node->dn_stat.st_size);
+  return 0;
+}
+
+/* If this function is nonzero (and diskfs_shortcut_symlink is set) it
+   is called to set a symlink.  If it returns EINVAL or isn't set,
+   then the normal method (writing the contents into the file data) is
+   used.  If it returns any other error, it is returned to the user.  */
+error_t (*diskfs_create_symlink_hook)(struct node *np, char *target) =
+  write_symlink;
+
+/* If this function is nonzero (and diskfs_shortcut_symlink is set) it
+   is called to read the contents of a symlink.  If it returns EINVAL or
+   isn't set, then the normal method (reading from the file data) is
+   used.  If it returns any other error, it is returned to the user. */
+error_t (*diskfs_read_symlink_hook)(struct node *np, char *target) =
+  read_symlink;
+
 /* Called when all hard ports have gone away. */
 void
 diskfs_shutdown_soft_ports ()
diff -ru hurd-0.0/ext2fs/pager.c hurd-0.1/ext2fs/pager.c
--- hurd-0.0/ext2fs/pager.c	Fri Aug  2 16:23:22 1996
+++ hurd-0.1/ext2fs/pager.c	Tue Sep  3 10:20:44 1996
@@ -32,8 +32,38 @@
 #define MAY_CACHE 1
 #endif
 
-/* ---------------------------------------------------------------- */
+#define STATS
+
+#ifdef STATS
+struct ext2fs_pager_stats
+{
+  spin_lock_t lock;
+
+  unsigned long disk_pageins;
+  unsigned long disk_pageouts;
+
+  unsigned long file_pageins;
+  unsigned long file_pagein_reads; /* Device reads done by file pagein */
+  unsigned long file_pagein_freed_bufs;	/* Discarded pages */
+  unsigned long file_pagein_alloced_bufs; /* Allocated pages */
+
+  unsigned long file_pageouts;
+
+  unsigned long file_page_unlocks;
+  unsigned long file_grows;
+};
+
+static struct ext2fs_pager_stats ext2s_pager_stats;
 
+#define STAT_INC(field)							\
+do { spin_lock (&ext2s_pager_stats.lock);					\
+     ext2s_pager_stats.field++;							\
+     spin_unlock (&ext2s_pager_stats.lock); } while (0)
+
+#else /* !STATS */
+#define STAT_INC(field) /* nop */0
+#endif /* STATS */
+
 /* Find the location on disk of page OFFSET in NODE.  Return the disk block
    in BLOCK (if unallocated, then return 0).  If *LOCK is 0, then it a reader
    lock is aquired on NODE's ALLOC_LOCK before doing anything, and left
@@ -94,6 +124,8 @@
 	  int length = num_pending_blocks << log2_block_size;
 	  vm_address_t new_buf;
 
+	  STAT_INC (file_pagein_reads);
+
 	  err = diskfs_device_read_sync (dev_block, &new_buf, length);
 	  if (err)
 	    return err;
@@ -105,7 +137,8 @@
 	    {
 	      /* We've already got some buffer, so copy into it.  */
 	      bcopy ((char *)new_buf, (char *)*buf + offs, length);
-	      vm_deallocate (mach_task_self (), new_buf, length);
+	      free_page_buf (new_buf);
+	      STAT_INC (file_pagein_freed_bufs);
 	    }
 
 	  offs += length;
@@ -115,6 +148,8 @@
       return 0;
     }
 
+  STAT_INC (file_pageins);
+
   *writelock = 0;
 
   if (page >= node->allocsize)
@@ -151,9 +186,10 @@
 	  if (offs == 0)
 	    /* No page allocated to read into yet.  */
 	    {
-	      err = vm_allocate (mach_task_self (), buf, vm_page_size, 1);
-	      if (err)
+	      *buf = get_page_buf ();
+	      if (! *buf)
 		break;
+	      STAT_INC (file_pagein_alloced_bufs);
 	    }
 	  bzero ((char *)*buf + offs, block_size);
 	  offs += block_size;
@@ -284,6 +320,8 @@
 
   ext2_debug ("writing inode %d page %d[%d]", node->cache_id, offset, left);
 
+  STAT_INC (file_pageouts);
+
   while (left > 0)
     {
       err = find_block (node, offset, &block, &lock);
@@ -338,6 +376,8 @@
 
   ext2_debug ("writing disk page %d[%d]", page, length);
 
+  STAT_INC (disk_pageouts);
+
   if (modified_global_blocks)
     /* Be picky about which blocks in a page that we write.  */
     {
@@ -465,6 +505,8 @@
 		    page, vm_page_size, node->cache_id);
 #endif
 
+      STAT_INC (file_page_unlocks);
+
       rwlock_writer_unlock (&dn->alloc_lock);
 
       if (err == ENOSPC)
@@ -553,6 +595,8 @@
 		  (old_page_end_block > end_block);
 	    }
 	}
+
+      STAT_INC (file_grows);
 
       ext2_debug ("new size: %ld%s.", new_size,
 		  dn->last_page_partially_writable
diff -ru hurd-0.0/ext2fs/truncate.c hurd-0.1/ext2fs/truncate.c
--- hurd-0.0/ext2fs/truncate.c	Fri Aug  2 16:23:22 1996
+++ hurd-0.1/ext2fs/truncate.c	Tue Sep  3 10:20:44 1996
@@ -277,6 +277,18 @@
   if (length >= node->dn_stat.st_size)
     return 0;
 
+  if (! node->dn_stat.st_blocks)
+    /* There aren't really any blocks allocated, so just frob the size.  This
+       is true for fast symlinks, and also apparently for some device nodes
+       in linux.  */
+    {
+      node->dn_stat.st_size = length;
+      node->dn_set_mtime = 1;
+      node->dn_set_ctime = 1;
+      diskfs_node_update (node, 1);
+      return 0;
+    }
+
   /*
    * If the file is not being truncated to a block boundary, the
    * contents of the partial block following the end of the file must be
Only in hurd-0.0: fsck
diff -ru hurd-0.0/hurd/ChangeLog hurd-0.1/hurd/ChangeLog
--- hurd-0.0/hurd/ChangeLog	Wed Jul 17 18:54:47 1996
+++ hurd-0.1/hurd/ChangeLog	Thu Sep  5 10:39:48 1996
@@ -1,3 +1,7 @@
+Thu Sep  5 10:39:40 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* version.h: File removed.
+
 Wed Jul 17 14:30:36 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>
 
 	* Makefile: gs/install-hdrs/install-headers/g.
